-- Guide to Purchasing the Complete Edition of Euphoria
-- written by Junko C. Miura of Rapid Deployment Software
-- If you have trouble running this program, send e-mail 
-- to: jcmiura@attcanada.net

include misc.e
include get.e
include graphics.e
include image.e

-- packages
constant WIN = "WIN32 + DOS32",
	 DOS = "DOS32",
	 LNX = "Linux",
	 PLNX = " + Linux"

-- prices
constant COMPLETE_WIN = 39,
	 COMPLETE_LNX = 25,
	 COMPLETE_ALL = 59,
	 SH = 5,
	 DISCOUNT = 15

function string(integer amount)
    return sprintf("%d", amount)
end function

constant COMPLETE_WIN_ = string(COMPLETE_WIN),
	 COMPLETE_LNX_ = string(COMPLETE_LNX),
	 COMPLETE_ALL_ = string(COMPLETE_ALL),
	 UPGRADE_WIN_ = string(COMPLETE_WIN - DISCOUNT),
	 UPGRADE_ALL_ = string(COMPLETE_ALL - DISCOUNT),
	 SH_ = string(SH),
	 DISCOUNT_ = string(DISCOUNT)

constant strEsc = 
 "Fill in or change the above information. &EPress 'Esc' key when " &
 "finished&7"

constant strGreeting0 =
 "\n\nYou will be asked several questions in the following menu screens. " &
 "Whether you are registering for the first time, or upgrading, " & 
 "this tool will select the most " &
 "convenient way for you to order the Complete Edition " &
 "of Euphoria. " &
 "\n\n&4If you want to change any of your choices, you can always " &
 "run this program again.&7"

constant strGreeting =
 "\n\nEuphoria runs on Windows, DOS and Linux platforms." &
 "\n\nYou can choose from the following selections:" &
 "\n\t- &9" & WIN & "&7 package ($" & COMPLETE_WIN_ & ")" &
 "\n\t- &2" & LNX & "&7 package ($" & COMPLETE_LNX_ & ")" &
 "\n\t- &9" & WIN & "&2" & PLNX & "&7 package ($" & COMPLETE_ALL_ & ")" &
 "\n\nShipping and handling is $" & SH_ & "." &
 "\n\nIf you have access to the World Wide Web and you don't require " &
 "a disk or receipt, you can " &
 "&4save the shipping and handling cost&7. " &
 "\n\n&3All prices are in U.S. dollars.&7"

constant strGreeting1 = 
 "\n\nWe offer a special discounted price for registered users who wish " &
 "to upgrade:" &
 "\n\n\t- Upgrade price of &9" & WIN & "&7 package ($" & UPGRADE_WIN_ &
 ")\n\t- Upgrade price of &9" & WIN & "&2" & PLNX & "&7 package ($" &
 UPGRADE_ALL_ & ")\n\n\nTo be eligible for the &9" & WIN & "&7 upgrade " &
 "price, you must have previously registered for the &9" & WIN &
 "&7 or &9" & DOS & "&7 package." &
 "\n\nRegistering for &2" & LNX & "&7-only does &Fnot&7 entitle you to a " &
 "discount on the &9" & WIN & "&7 package, but does allow you a discount " &
 "on the &9" & WIN & "&2" & PLNX & "&7 package."

constant strCC1 = 
 "\t\t&DOrdering through DigiBuy\n" &
 "\t\t------------------------&7\n\n" &
 "You can order Euphoria from DigiBuy using your " & 
 "&4MasterCard&7,&4 Visa&7,&4 American Express &7or&4 Discover Card&7." &
 "\n\n\nGo to our Web site:\n\n\t" &
 "&3http://www.RapidEuphoria.com/ &7\n\n" &
 "and click \"Register Now On-Line!\""
 
constant strCC3 = 
 "\t\t&DOrdering through DigiBuy (continued)\n" &
 "\t\t------------------------------------&7\n\n" &
 "On the DigiBuy ordering page, select "
   
constant strCC4 =  
 "\nFor technical assistance, volume discounts, or any other enquiries " &
 "please contact Rapid Deployment Software directly.\n\n"
 
constant strRDS0 =
 "\t&DOrdering directly from Rapid Deployment Software (continued)\n" &
 "\t------------------------------------------------------------&7" 

constant strRDSGreet =
 "\t&DOrdering directly from Rapid Deployment Software\n" &
 "\t------------------------------------------------&7" &
 "\n\n&4You can order by postal mail directly from " & 
 "Rapid Deployment Software.&7" &
 "\n\nYou need to send an order form to RDS by postal mail. \n\nNext, you " &
 "will be asked some questions, so we can create an order form " &
 "for you. Send this order form to RDS when you decide to register." &
 "\n\nFor your convenience, you can print the file &EMYORDER.FRM&7 " &
 "and send it along with your check or money order. If you don't " &
 "have a printer, just copy the essential information to a sheet of paper."

constant strRDSUpgrade =
 strRDS0 & 
 "\n\nYou can upgrade to v2.2 and get a discount of $" &
 DISCOUNT_ & ".00 U.S. \n\nYou must mail us the order form " &
 "&EMYORDER.FRM&7 that you generate from this tool " &
 "along with your check."

constant strRDSFormNotice0 =
 "&3Please make sure that the following data is correct.&7\n\n"

constant strRDSOrder = 
 "\n         Euphoria Complete Edition Order Form v2.2 (or later)" &
 "\n         ----------------------------------------------------" &
 "\n\n Enclose a check or money order payable to:\n" &
 "      Rapid Deployment Software\n" &
 "      130 Holm Crescent\n" &
 "      Thornhill, Ontario\n" &
 "      L3T 5J3\n" &
 "      CANADA\n\n\n" &
 " Ship Euphoria to:\n\n"

constant strRDSFormNotice =
 strRDS0 & 
 "\n\n&EMYORDER.FRM&7 has been created in the current directory. " &
 "&4You can print it and send it with a check or money order to RDS " &
 "when you are ready.&7 If you don't have a printer, just copy the " &
 "essential information to a sheet of paper." &
 "\n\n&3The total cost is U.S. $"
 
constant strRDSFormNotice1 =
 "\n\n&3We can accept a personal check or money order " &
 "\n\t\tin your country's currency, or " &
 "\n\t\tin Canadian dollars, or " &
 "\n\t\tin U.S. dollars." &
 "\n\nPlease do a fair conversion from the U.S. dollar price.&7 "

constant strRDSFormNotice2 =
 "\n\n&3You can make a check or money order at your bank or " &
 "post office. Please make it in either U.S. dollars, or preferably " &
 "in Canadian dollars.&7"

constant strRDSCheck =  
 strRDS0 & 
 "\n\nMake your check or money order payable to: " &
 "\n\n\t    &4Rapid Deployment Software&7 " &
 "\n\n\t    130 Holm Crescent " &
 "\n\t    Thornhill, Ontario " &
 "\n\t    L3T 5J3 " &
 "\n\t    CANADA " &
 "\n\n\t    Phone (905) 764-8636 " &
 "\n\t    Fax   (905) 764-7615\n\n" &
 "\nand include a print-out of &EMYORDER.FRM&7\n\n"

--****************************************************************************
constant TRUE = 1, FALSE = 0, SCREEN = 1 
constant CR = 13, TAB = 9, ARROW_LEFT = 331, ARROW_RIGHT = 333, 
	 ARROW_UP = 328, ARROW_DOWN = 336, ESC = 27, DELETE = 339,
	 FORM_FEED = 12
constant USA = 'U', CANADA = 'C', OTHER = 'O'
constant YES = 'Y', NO = 'N'
constant WIN_DOS = 'W', LNX_ONLY = 'L'
integer BS
if platform() = LINUX then
    BS = 263
else
    BS = 8
end if

-- field types and indices of the various fields for the menu screen
constant STRING = 1, NUMERIC = 2
constant PROMPT = 1,
	 DATA_TYPE = 2,
	 LINE = 3,
	 COLUMN = 4,
	 DATA_COLUMN = 5,
	 LENGTH = 6,
	 MAX_COLUMN_NO = 7, -- cursor can come, but no entry in THIS column
	 DEFAULT_VALUE = 8,
	 UNIT_PRICE = 9
    
constant FINISH = 0, UP = 1, DOWN = 2


sequence fields -- fields info for the menu screen, definition comes later
sequence input_values   -- user response to fields

integer COUNTRY_INDEX, EMAIL_INDEX, UPGRADE_INDEX,
	SHIPPING_INDEX, PLATFORM_INDEX
    -- field specific variables and constants finish here

integer screenWidth, maxNumLines, numColumns, monoMonitor
integer country, whichPkg, isUpgrade
integer haveCC
integer countryOk, downloadOnly, totalPrice, printNow


function indexLastNonBlankChar(sequence str)
    integer allBlanks, i
    
    i = length(str)
    allBlanks = TRUE
    while allBlanks and i >= 1 do
	if str[i] = ' ' then
	    i -= 1
	else
	    allBlanks = FALSE
	end if
    end while
    return i
end function


procedure set_color(integer color)
    if monoMonitor then
	return
    else
	text_color(color)
    end if
end procedure


procedure waitResponse(sequence str)
-- wait for the key response indicated by a parameter   
    integer char
    
    position(maxNumLines, screenWidth - length(str))
    puts(SCREEN,str) 
    while TRUE do
	char = wait_key()
	if char = CR or '\n' then
	    clear_screen()
	    exit
	end if
    end while
end procedure


function upper_key()
    integer char
    object line
    
    line = gets(0)
    if sequence(line) then
	char = line[1]
    else
	char = CR
    end if
    if char >= 'a' and char <= 'z' then
	char += 'A' - 'a'
    end if
    return char
end function


procedure color_puts(integer color, object x)
    set_color(color)
    puts(SCREEN, x)
    set_color(WHITE)
end procedure


procedure display(sequence paragraph)
-- neatly display some multi-colored text
    integer column, i

    column = 1
    i = 1
    while i <= length(paragraph) do
	if paragraph[i] = '\n' then
	    puts(SCREEN, paragraph[i])
	    column = 1
	elsif paragraph[i] = '&' then
	    set_color(find(paragraph[i+1], "0123456789ABCDEF")-1)
	    i += 1
	else    
	    puts(SCREEN, paragraph[i])
	    column += 1
	    if column > numColumns and 
		(paragraph[i] = ' ' or paragraph[i] = '-') then
		puts(SCREEN, '\n')
		column = 1
	    end if
	end if
	i += 1
    end while
end procedure


procedure putGreeting(sequence s)
    color_puts(BRIGHT_MAGENTA, "\n\tHow to Register for the Complete " &
		"Edition of Euphoria\n\t-----------------------------" &
		"-----------------------\n\n")
    display(s)
    waitResponse("press 'Enter' for NEXT")
end procedure


procedure greetings()
    sequence vc
    
    vc = video_config()
    monoMonitor = not vc[VC_COLOR]
    screenWidth = vc[VC_COLUMNS]
    numColumns = screenWidth - 15
    maxNumLines = vc[VC_LINES]
    clear_screen()
    putGreeting(strGreeting0)
    putGreeting(strGreeting)
    putGreeting(strGreeting1)
end procedure


function ask(sequence str)
    integer i
    sequence choices, pos 
    
    choices = {}
    i = 1
    while i <= length(str) do
	if str[i] = '&' then
	    i += 1           -- note i is incremented here by one already
	    color_puts(YELLOW, str[i])
	    if str[i] != '_' then
		choices &= str[i] 
	    end if
	else
	    puts(SCREEN, str[i])
	end if
	i += 1               -- increment i
    end while
    
    if length(choices) > 0 then
	pos = get_position()
	position(pos[1], pos[2] - 1)
	while TRUE do
	    i = find(upper_key(), choices) 
	    if i != 0 then
		return choices[i]
	    else 
		puts(SCREEN, "\nPlease enter ")
		for j = 1 to length(choices) - 2 do
		    color_puts(YELLOW, choices[j])
		    puts(SCREEN, ", ")
		end for
		color_puts(YELLOW, choices[length(choices) - 1])
		puts(SCREEN, " or ")
		color_puts(YELLOW, choices[length(choices)])
		puts(SCREEN, ':')
	    end if
	end while
    end if
end function


procedure CCard()
    integer cost
    sequence str
    
    clear_screen()
    display(strCC1)
    waitResponse("press 'Enter' for NEXT")
    
    str = "&4Euphoria "
    if whichPkg = WIN_DOS then
	cost = COMPLETE_WIN
	str = str & "&9" & WIN & " "
    elsif whichPkg = LNX_ONLY then
	cost = COMPLETE_LNX
	str = str & "&2" & LNX & " "
    else
	cost = COMPLETE_ALL
	str = str & "&9" & WIN & "&2" & PLNX & " "
    end if
    
    if isUpgrade = YES then
	cost = cost - DISCOUNT
	str &= "&4upgrade, "
    end if
    if downloadOnly = NO then
	cost += SH
	str &= "&4with shipping and handling"
    else
	str &= "&4with download-only option"
    end if
    
    display(strCC3 & str & "&7. The charge will be $" & 
	    string(cost) & ".00 U.S.\n\n" & strCC4)
end procedure


procedure displayFields()
    sequence fieldInsert

    -- define the description of the various fields for the menu screen
    COUNTRY_INDEX = 7       -- these are indices into fields, better NOT
    EMAIL_INDEX = 8         --   to be constants
    PLATFORM_INDEX = 9
    UPGRADE_INDEX = 10      -- note that UPGRADE_INDEX and SHIPPING_INDEX are
    SHIPPING_INDEX = 10     --   the same value
    
    fields = 
	{
	  {"Your Name",       STRING,  5, 7, 27, 35, screenWidth, "", ""},
	  {"Your Address",    STRING,  7, 7, 27, 35, screenWidth, "", ""},
	  {"",                STRING,  8, 7, 27, 35, screenWidth, "", ""},
	  {"",                STRING,  9, 7, 27, 35, screenWidth, "", ""},
	  {"",                STRING, 10, 7, 27, 35, screenWidth, "", ""},
	  {"",                STRING, 11, 7, 27, 35, screenWidth, "", ""},
	  {"Country",         STRING, 12, 7, 27, 30, screenWidth, "", ""},
	  {"E-mail address",  STRING, 14, 7, 27, 35, screenWidth, "", ""}
	}
	  
    if whichPkg = WIN_DOS then
	fields &= 
	{  
	  {"Complete Edition WIN32 + DOS32          @  $" &
			      sprintf("%2d.00", COMPLETE_WIN),  
			      NUMERIC, 18, 7, 62, 2, 64, "1", COMPLETE_WIN}
	}
    elsif whichPkg = LNX_ONLY then
	fields &= 
	{  
	  {"Complete Edition Linux                  @  $" &
			      sprintf("%2d.00", COMPLETE_LNX),  
			      NUMERIC, 18, 7, 62, 2, 64, "1", COMPLETE_LNX}
	}
    else
	fields &= 
	{  
	  {"Complete Edition WIN32 + DOS32 + Linux  @  $" &
			      sprintf("%2d.00", COMPLETE_ALL),  
			      NUMERIC, 18, 7, 62, 2, 64, "1", COMPLETE_ALL}
	}
    end if
    fields &=
	{  
	  {"shipping/handling                       @  $",
			      NUMERIC, 19, 7, 62, 2, 64, "1", SH}
	}

    fieldInsert =
	  {"upgrade discount                        @ -$" &
			      sprintf("%2d.00", DISCOUNT),
			      NUMERIC, 19, 7, 62, 2, 64, "1", -DISCOUNT}
    
    if country = USA then
	fields[COUNTRY_INDEX][DEFAULT_VALUE] = "U.S.A."
	fields[SHIPPING_INDEX][PROMPT] &= sprintf("%2d.00", SH)
    elsif country = CANADA then
	fields[COUNTRY_INDEX][DEFAULT_VALUE] = "CANADA"
	fields[SHIPPING_INDEX][PROMPT] &= sprintf("%2d.00", SH)
    else
	fields[SHIPPING_INDEX][PROMPT] &= sprintf("%2d.00", SH)
    end if
    
    if isUpgrade = YES then
	fields = append(append(fields[1..PLATFORM_INDEX], fieldInsert),
			fields[SHIPPING_INDEX])
	SHIPPING_INDEX += 1
	fields[SHIPPING_INDEX][LINE] += 1
    end if
    
    if downloadOnly = YES then
	fields[SHIPPING_INDEX][DEFAULT_VALUE] = "0"
    end if
    
    clear_screen()
    display(strRDS0)

    -- display all the prompts
    for i = 1 to length(fields) do
	position(fields[i][LINE], fields[i][COLUMN])
	puts(SCREEN, fields[i][PROMPT])
	position(fields[i][LINE], fields[i][DATA_COLUMN])
	puts(SCREEN, repeat('_', fields[i][LENGTH]))
	position(fields[i][LINE], fields[i][DATA_COLUMN])
	puts(SCREEN, fields[i][DEFAULT_VALUE])
    end for
    position(17, 7)
    color_puts(RED, "description                                 price" &
	       "   quantity\n")
end procedure


function key_gets(integer fieldNo)
   integer line, init_column, column, indicator, char, maxColNo, num, num1
   sequence cursor, temp, temp1
   
   cursor = get_position()
   line = cursor[1]
   init_column = cursor[2]
   maxColNo = fields[fieldNo][MAX_COLUMN_NO]
   column = init_column
   while TRUE do
	char = wait_key()
	
	if char = CR or char = '\n' or char = TAB or char = ARROW_DOWN then
	    indicator = DOWN
	    exit
	
	elsif char = ARROW_UP then
	    indicator = UP
	    exit

	elsif char = ESC then
	    indicator = FINISH
	    exit
	
	elsif char = DELETE then
	    if column >= init_column and column < maxColNo then
		temp = save_text_image({line, column + 1},
				       {line, maxColNo - 1}) 
		temp = temp[1]          -- temp now is a single sequence
		temp1 = ""
		for j = 1 to length(temp) - 1 by 2 do
		    temp1 = append(temp1, temp[j])
		end for
		temp1 = temp1[1..indexLastNonBlankChar(temp1)]
		puts(SCREEN, temp1)
		num = fields[fieldNo][DATA_COLUMN] + fields[fieldNo][LENGTH]
		num1 = column + length(temp1)
		if num1 < num then      -- num1 is a cursor column position
		    puts(SCREEN, repeat('_', num - num1))
		else
		    puts(SCREEN, repeat(' ', maxColNo - num1))
		end if
		position(line, column)
	    end if
	
	elsif char = ARROW_RIGHT then
	    if column < maxColNo then
		column += 1
		position(line, column)
	    end if
	    
	elsif char = BS then
	    if column > init_column then
		if column < maxColNo then
		    temp = save_text_image({line, column}, 
					   {line, maxColNo - 1}) 
		    temp = temp[1]          -- temp now is a single sequence
		    temp1 = ""
		    for j = 1 to length(temp) - 1 by 2 do
			temp1 = append(temp1, temp[j])
		    end for
		    temp1 = temp1[1..indexLastNonBlankChar(temp1)]
		    column -= 1
		    position(line, column)
		    puts(SCREEN, temp1)
		    num = fields[fieldNo][DATA_COLUMN] + 
			  fields[fieldNo][LENGTH]
		    num1 = column + length(temp1)
		    if num1 < num then      -- num1 is a cursor column position
			puts(SCREEN, repeat('_', num - num1))
		    else
			puts(SCREEN, repeat(' ', maxColNo - num1))
		    end if
		    position(line, column)
		elsif column = maxColNo then
		    column -= 1
		    position(line, column)
		end if
	    end if
	    
	elsif char = ARROW_LEFT then
	    if column > init_column then
		column -= 1
		position(line, column)
	    end if
	    
	elsif char >= 32  and char <= 255 then
	    if column < maxColNo then
		puts(SCREEN, char)
		column += 1
	    end if
	
	end if
    end while
    return indicator
end function


procedure get_data()
-- get field values from user and return them as a sequence
    integer fieldNo, keyResults
    sequence temp, temp1

    displayFields()
    position(maxNumLines, screenWidth - length(strEsc))
    display(strEsc) 
    
    -- let the user enter all data
    fieldNo = 1
    while TRUE do
	position(fields[fieldNo][LINE], fields[fieldNo][DATA_COLUMN])
	keyResults = key_gets(fieldNo)
	if keyResults = DOWN then
	    if fieldNo < length(fields) then
		fieldNo += 1
	    else
		fieldNo = 1
	    end if
	
	elsif keyResults = UP then
	    if fieldNo > 1 then
		fieldNo -= 1
	    end if
	
	elsif keyResults = FINISH then
	    exit

	end if
    end while
    
    -- collect all the input
    input_values = repeat("", length(fields))
    totalPrice = 0
    for i = 1 to length(fields) do
	temp = save_text_image({fields[i][LINE], fields[i][DATA_COLUMN]},
			 {fields[i][LINE], fields[i][MAX_COLUMN_NO] - 1})
	temp = temp[1]
	for j = 1 to length(temp) - 1 by 2 do
	    if temp[j] = '_' then
		temp[j] = ' '
	    end if
	    input_values[i] = append(input_values[i], temp[j])
	end for
	
	if fields[i][DATA_TYPE] = NUMERIC then
	    temp = value(input_values[i])
	    if temp[1] = GET_SUCCESS then
		input_values[i] = temp[2]
	    elsif temp[1] = GET_EOF then    -- nothing in the field
		input_values[i] = 0
	    else        -- non-numeric data in the field. Assign a default.
		temp1 = value(fields[i][DEFAULT_VALUE])
		input_values[i] = temp1[2]
	    end if
	    totalPrice += input_values[i] * fields[i][UNIT_PRICE]
	end if
    end for
end procedure

procedure displayCost()
    integer fn, k, totalCadPrice
    
    clear_screen()
    display(strRDSFormNotice0)
    -- display data for user's check on the screen here, then create a file
    fn = open("myorder.frm", "w")
    if fn = -1 then
	display("Can't create MYORDER.FRM ! We will abort execution.")
	abort(1)
    end if
    for j = 1 to 2 do
	if j = 1 then
	    k = SCREEN
	else
	    k = fn
	    puts(k, strRDSOrder)
	end if
	for i = 1 to length(input_values) do
	    if fields[i][DATA_TYPE] = NUMERIC then
		printf(k, " %-60s%d\n", {fields[i][PROMPT], input_values[i]})
	    elsif i = EMAIL_INDEX then
		printf(k, "\n %-20s%s\n\n\n", 
		       {fields[i][PROMPT], input_values[i]})
		puts(k, " description                                 price" &
			"       quantity\n")
		puts(k, " --------------------------------------      -----" &
			"       --------\n")
	    else 
		printf(k, " %-20s%s\n", {fields[i][PROMPT], input_values[i]})
	    end if
	end for
	printf(k, "%72s\n\n", {"----------------------------"})
	printf(k, "%51s%5d.00 %s\n", {"Total:", totalPrice, "U.S. dollars"})
	
	if country != USA then
	    totalCadPrice = floor(totalPrice * 1.52)
	    printf(k, "%51s%d.00 %s\n", {"(We will also accept ",
					  totalCadPrice, "Canadian dollars)"})
	end if
	puts(k, "\n")
    end for
	
    if input_values[SHIPPING_INDEX] = 0 then
	puts(fn, "\n\n You will download the Complete Edition software " &
		"from the \n World Wide Web. Send e-mail to rds@attcanada.net" &
		" and we will\n give you the necessary " &
		"instructions. Nothing will be\n shipped to you by postal" &
		" mail.\n\n")
    end if
    puts(fn, 12) -- add a form feed
    close(fn)
    
    waitResponse("press 'Enter' for NEXT")
    display(strRDSFormNotice)
    printf(SCREEN, "%d.00", totalPrice)     -- printed in some bright color
    if country != USA then
	printf(SCREEN, " (or %d.00 Canadian dollars)", totalCadPrice) 
    end if
    set_color(WHITE)                        -- change back the foreground color
    if country = OTHER then
	if countryOk = YES then
	    display(strRDSFormNotice1)
	else
	    display(strRDSFormNotice2)
	end if
    end if
    waitResponse("press 'Enter' for NEXT")
end procedure


procedure printRDSOrder()
    integer p, of, tryAgain
    object line
    
    puts(SCREEN, "\n\nPress any key when your printer is ready.")
    if wait_key() then
    end if
    if platform() = LINUX then
	system("cat myorder.frm | lpr", 2)
    else    
	p = open("PRN", "w")
	if p = -1 then
	    color_puts(RED, "\n\ncould not open printer. Make sure it " &
			    "is on and connected.")
	    tryAgain = ask("\n\nWould you like to try again? &Yes or &No &_")
	    if tryAgain = YES then
		p = open("PRN", "w")
		if p = -1 then
		    color_puts(RED, "\n\nStill can't open printer. You can " &
				    "print MYORDER.FRM file at a later time.")
		    waitResponse("press 'Enter' for NEXT")
		    return
		end if
	    else
		return
	    end if
	end if
	of = open("myorder.frm", "r")
	if of = -1 then
	    display("\n\nCan't open MYORDER.FRM !")
	    waitResponse("press 'Enter' for NEXT")
	    return
	end if
    
	while TRUE do
	    line = gets(of)
	    if atom(line) then
		exit
	    end if
	    puts(p, line)
	end while
	puts(p, FORM_FEED)
	close(p)
	close(of)
    end if
end procedure


procedure RDSOrder()
    integer create
    
    clear_screen()
    display(strRDSGreet)
    create = ask("\n\nWould you like to create an order form now? " &
		 "&Yes or &No &_")
    clear_screen()
    if create = NO then
	return
    end if

    display(strRDS0)
    country = ask("\n\nWhich country do you live in, &U.S.A., &Canada " &
		  "or &Other? &_")
    countryOk = YES         -- USA or Canada currency is accepted
    if country = OTHER then
	countryOk = ask("\n\nDo you live in one of the following " &
		"countries?\n\n\t" &
		"\n\tAustralia,    Austria,      Barbados,      Belgium, " &
		"\n\tBritain,      Canada,       Denmark,       Finland, " &
		"\n\tFrance,       Greece,       Germany,       Hong Kong, " &
		"\n\tIreland,      Japan,        Mexico,        Netherlands, " &
		"\n\tNew Zealand,  Norway,       Portugal,      Spain, " &
		"\n\tSweden,       Switzerland,  United States" &
		"\n\n\t\t&Yes or &No &_")
    end if
    clear_screen()

    if isUpgrade = YES then
	display(strRDSUpgrade)
	waitResponse("press 'Enter' for NEXT")
    end if
    get_data()
    displayCost()
    display(strRDS0)
    printNow = ask("\n\nWould you like to print your order form right " &
		   "now? &Yes or &No &_")
    if printNow = YES then
	printRDSOrder()     
    end if
    clear_screen()
    display(strRDSCheck)
end procedure


-- *** start the main execution part
    greetings()
    whichPkg = ask("\nWhich package do you want to purchase?" &
		   "\n&WIN32+DOS32, &Linux or &All three &_")
    
    isUpgrade = NO
    if whichPkg != LNX_ONLY then
	isUpgrade = ask("\n\nAre you currently a registered user of " &
			"Euphoria on WIN32 or DOS32? " &
			"&Yes or &No &_")
	if isUpgrade = NO and whichPkg != WIN_DOS then
	    isUpgrade = ask("\n\nAre you currently a registered user of " &
			    "Euphoria on Linux? " &
			    "&Yes or &No &_")
	end if
    end if
    
    downloadOnly = ask("\n\nWould you like to take advantage of the " &
		       "\"Download-only\" option? &Yes or &No &_") 
    
    -- keep up-to-date which CCards are accepted by DigiBuy all the time !  
    haveCC = ask("\n\nDo you have a credit card, such as\n\t\t" &
		 "MasterCard, \n\t\tVisa, \n\t\tAmerican Express " &
		 "or \n\t\tDiscover Card, \n\tand do you want to " & 
		 "use it? \n\t\t\t&Yes or &No &_")
    
    if haveCC = YES then
	CCard()
    else
	RDSOrder()
    end if          

